package com.tmax.openframe;

import com.tmax.openframe.response.ResponseCode;
import com.tmax.openframe.Handling;
import com.tmax.openframe.option.*;
import com.tmax.openframe.eib.EIB;
import com.tmax.openframe.task.Task;
import com.tmax.openframe.SystemData;
import com.tmax.openframe.support.exception.*;
import com.tmax.openframe.dof.*;
import com.tmax.openframe.dto.*;
import com.tmax.openframe.mapper.*;
import com.tmax.proobject.engine.waitobject.WaitObject;
import com.tmax.openframe.taskcontrol.*;
import com.tmax.openframe.counter.*;
import com.tmax.openframe.file.*;
import com.tmax.openframe.intervalcontrol.*;
import com.tmax.openframe.command.*;
import java.util.Objects;
import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.dto.OIVPINSR_InputDto;
import com.tmax.openframe.dto.OIVPINSR_OutputDto;
import com.tmax.openframe.variable.OIVPINSR_VariableContainer;
import com.tmax.openframe.variable.condition.*;
import com.tmax.openframe.variable.group.*;
import com.tmax.proobject.engine.waitobject.WaitObject;
import com.tmax.proobject.model.dataobject.DataObject;
import java.lang.Runnable;
import java.math.*;
import java.util.*;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public class OIVPINSR implements Runnable {
    private @Getter Integer returnValue = 0;
    private @Getter OIVPINSR_VariableContainer container = new OIVPINSR_VariableContainer();
    Runnable _0000_MAIN = this::_0000_MAIN;
    Runnable _0100_FIRST_TIME = this::_0100_FIRST_TIME;
    Runnable _0200_INSERT = this::_0200_INSERT;
    Runnable _0300_GO_MAIN = this::_0300_GO_MAIN;
    Runnable _5100_ALWAYS_TEST = this::_5100_ALWAYS_TEST;
    Runnable _5200_DATE = this::_5200_DATE;
    Runnable _5300_RETURN_TRANS_ID = this::_5300_RETURN_TRANS_ID;
    Runnable _5400_QUIT = this::_5400_QUIT;
    Runnable _7100_RECEIVEMAP = this::_7100_RECEIVEMAP;
    Runnable _7200_SENDMAP = this::_7200_SENDMAP;
    Runnable _7250_SENDMAP_DATA = this::_7250_SENDMAP_DATA;
    Runnable _9100_INVALID_KEY = this::_9100_INVALID_KEY;
    Runnable _9999_ABORT = this::_9999_ABORT;
    Runnable GoTo;
    boolean Return;
    ArrayList<Runnable> MethodFlow = new ArrayList<>();
    {
        MethodFlow.add(_0000_MAIN);
        MethodFlow.add(_0100_FIRST_TIME);
        MethodFlow.add(_0200_INSERT);
        MethodFlow.add(_0300_GO_MAIN);
        MethodFlow.add(_5100_ALWAYS_TEST);
        MethodFlow.add(_5200_DATE);
        MethodFlow.add(_5300_RETURN_TRANS_ID);
        MethodFlow.add(_5400_QUIT);
        MethodFlow.add(_7100_RECEIVEMAP);
        MethodFlow.add(_7200_SENDMAP);
        MethodFlow.add(_7250_SENDMAP_DATA);
        MethodFlow.add(_9100_INVALID_KEY);
        MethodFlow.add(_9999_ABORT);
    }
    @Getter
    EIB eib = new Task().getEib();
    @Getter
    boolean Start;
    @Getter
    Handling handling = new Handling();
    @Getter
    SystemData systemData = new SystemData();
    @Getter
    @Setter
    WaitObject waitObject;
    @Getter
    @Setter
    OIVPINSR_InputDto inputDto;
    @Getter
    @Setter
    OIVPINSR_OutputDto outputDto;
    @Getter
    @Setter
    DataObject startInputDto;

    public OIVPINSR() {
        container.setDFHCOMMAREA(StringUtils.repeat(' ', 1));
    }

    public @Override void run() {
        run(_0000_MAIN, _9999_ABORT);
    }

    private void run(Runnable start) throws CicsException {
        run(start, null);
    }

    private void run(Runnable start, Runnable end) throws CicsException {
        List<Runnable> runList;
        if (end == null) {
            runList = Collections.singletonList(start);
        } else {
            runList = MethodFlow.subList(MethodFlow.indexOf(start),
                    MethodFlow.indexOf(end) + 1);
        }
        int i = 0;
        while (i < runList.size()) {
            runList.get(i).run();
            if (GoTo != null) {
                for (Runnable runUnit : runList) {
                    if (GoTo == runUnit) {
                        i = runList.indexOf(runUnit);
                        GoTo = null;
                        break;
                    }
                }
                if (GoTo != null) {
                    return;
                }
            } else {
                i++;
            }
            if (Return) {
                return;
            }
        }
    }

    void _0000_MAIN() throws CicsException {
        run(_5100_ALWAYS_TEST);
        if (GoTo != null || Return) {
            return;
        }
        if (OIVPINSR_WS_FIRST_TIME_FLAG_CONDITION.FIRST_TIME.test(container
                .getWS_FIRST_TIME_FLAG())) {
            run(_0100_FIRST_TIME);
            if (GoTo != null || Return) {
                return;
            }
        } else if (OIVPINSR_DEFINITIONS_OF_EIBAID_FIELD_CONDITION.ENTER_KEY
                .test(container.getDEFINITIONS_OF_EIBAID_FIELD())) {
            run(_0200_INSERT);
            if (GoTo != null || Return) {
                return;
            }
        } else if (OIVPINSR_DEFINITIONS_OF_EIBAID_FIELD_CONDITION.PF1_KEY
                .test(container.getDEFINITIONS_OF_EIBAID_FIELD())) {
            run(_0300_GO_MAIN);
            if (GoTo != null || Return) {
                return;
            }
        } else {
            run(_9100_INVALID_KEY);
            if (GoTo != null || Return) {
                return;
            }
        }
        run(_5300_RETURN_TRANS_ID);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0100_FIRST_TIME() throws CicsException {
        container.setOIVPM04I(OIVPINSR_OIVPM04I.createDefaultValueInstance());
        container.setMSGO("ENTER APPROPRIATE VALUES");
        run(_5200_DATE);
        if (GoTo != null || Return) {
            return;
        }
        // ("EXEC CICS ENQ RESOURCE('OIVPNCS') LENGTH(7) END-EXEC");
        try {
            EnqOption option = EnqOption.builder().resource("OIVPNCS")
                    .length(7).build();
            TaskControl.enq(option);
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS QUERY COUNTER('OIVPNCS') RESP(WS-RESPONSE-CODE) RESP2(WS-RESPONSE-CODE2) END-EXEC");
        try {
            QueryCounterOption option = QueryCounterOption.builder()
                    .counter("OIVPNCS").build();
            Counter.query(option);
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            container.setWS_RESPONSE_CODE2(eib.getEibResp2());
            if (GoTo != null)
                return;
        }
        if (container.getWS_RESPONSE_CODE() == ResponseCode.NORMAL
                .getResponseCode()) {
        } else if (container.getWS_RESPONSE_CODE() == ResponseCode.INVREQ
                .getResponseCode()) {
            if (container.getWS_RESPONSE_CODE2() == 201) {
                // ("EXEC CICS STARTBR FILE(FILE01) RIDFLD(START-KEY) KEYLENGTH(LEN) RESP(WS-RESPONSE-CODE) END-EXEC");
                try {
                    StartbrOption option = StartbrOption.builder()
                            .file(container.getFILE01())
                            .ridfld(String.valueOf(container.getSTART_KEY()))
                            .keylength((int) container.getLEN()).build();
                    File.startbr(option, OIVPDS_DOF.class);
                    container
                            .setSTART_KEY(Integer.parseInt(option.getRidfld()));
                } catch (CicsConditionException e) {
                } catch (RuntimeException e) {
                    GoTo = systemData.getErrorRunnable(e);
                } finally {
                    container.setWS_RESPONSE_CODE(eib.getEibResp());
                    if (GoTo != null)
                        return;
                }
                if (container.getWS_RESPONSE_CODE() == ResponseCode.ENDFILE
                        .getResponseCode()
                        || container.getWS_RESPONSE_CODE() == ResponseCode.NOTFND
                                .getResponseCode()) {
                    // ("EXEC CICS DEFINE COUNTER('OIVPNCS') VALUE(1) END-EXEC");
                    try {
                        DefineCounterOption option = DefineCounterOption
                                .builder().counter("OIVPNCS").value(1).build();
                        Counter.define(option);
                    } catch (CicsConditionException e) {
                        GoTo = systemData.getConditionRunnable(e);
                    } catch (RuntimeException e) {
                        GoTo = systemData.getErrorRunnable(e);
                    } finally {
                        if (GoTo != null)
                            return;
                    }
                } else {
                    do {
                        // ("EXEC CICS READNEXT FILE(FILE01) INTO(PEOPLE-INFO) RIDFLD(KEY01) KEYLENGTH(LEN) LENGTH(DATALEN) RESP(WS-RESPONSE-CODE) END-EXEC");
                        try {
                            ReadnextOption option = ReadnextOption
                                    .builder()
                                    .file(container.getFILE01())
                                    .into(OIVPINSR_PEOPLE_INFO_To_OIVPDS_DOMapper.INSTANCE
                                            .toTarget(container
                                                    .getPEOPLE_INFO()))
                                    .ridfld(String.valueOf(container.getKEY01()))
                                    .keylength((int) container.getLEN())
                                    .length((int) container.getDATALEN())
                                    .build();
                            File.readnext(option, OIVPDS_DOF.class);
                            container
                                    .setPEOPLE_INFO(OIVPINSR_PEOPLE_INFO_To_OIVPDS_DOMapper.INSTANCE
                                            .toSource((OIVPDS_DO) option
                                                    .getInto()));
                            container.setKEY01(Integer.parseInt(option
                                    .getRidfld()));
                        } catch (CicsConditionException e) {
                        } catch (RuntimeException e) {
                            GoTo = systemData.getErrorRunnable(e);
                        } finally {
                            container.setWS_RESPONSE_CODE(eib.getEibResp());
                            if (GoTo != null)
                                return;
                        }
                    } while (!(container.getWS_RESPONSE_CODE() == ResponseCode.ENDFILE
                            .getResponseCode() || container
                            .getWS_RESPONSE_CODE() == ResponseCode.NOTFND
                            .getResponseCode()));
                    container.setKEY01(container.getKEY01() + 1);
                    // ("EXEC CICS DEFINE COUNTER('OIVPNCS') VALUE(KEY01) END-EXEC");
                    try {
                        DefineCounterOption option = DefineCounterOption
                                .builder().counter("OIVPNCS")
                                .value((int) container.getKEY01()).build();
                        Counter.define(option);
                    } catch (CicsConditionException e) {
                        GoTo = systemData.getConditionRunnable(e);
                    } catch (RuntimeException e) {
                        GoTo = systemData.getErrorRunnable(e);
                    } finally {
                        if (GoTo != null)
                            return;
                    }
                    // ("EXEC CICS ENDBR FILE(FILE01) END-EXEC");
                    try {
                        EndbrOption option = EndbrOption.builder()
                                .file(container.getFILE01()).build();
                        File.endbr(option);
                    } catch (CicsConditionException e) {
                        GoTo = systemData.getConditionRunnable(e);
                    } catch (RuntimeException e) {
                        GoTo = systemData.getErrorRunnable(e);
                    } finally {
                        if (GoTo != null)
                            return;
                    }
                }
            }
        } else {
            run(_9999_ABORT);
            if (GoTo != null || Return) {
                return;
            }
        }
        // ("EXEC CICS QUERY COUNTER('OIVPNCS') VALUE(WS-KEY) END-EXEC");
        try {
            QueryCounterOption option = QueryCounterOption.builder()
                    .counter("OIVPNCS")
                    .value((int) container.getPEOPLE_INFO().getWS_KEY())
                    .build();
            Counter.query(option);
            container.getPEOPLE_INFO().setWS_KEY(option.getValue());
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        container.setIDENO(String.valueOf(container.getPEOPLE_INFO()
                .getWS_KEY()));
        // ("EXEC CICS DEQ RESOURCE('OIVPNCS') LENGTH(7) END-EXEC");
        try {
            DeqOption option = DeqOption.builder().resource("OIVPNCS")
                    .length(7).build();
            TaskControl.deq(option);
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        run(_7200_SENDMAP);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0200_INSERT() throws CicsException {
        run(_7100_RECEIVEMAP);
        if (GoTo != null || Return) {
            return;
        }
        container.getPEOPLE_INFO().setWS_NAME(
                container.getOIVPM04I().getNAMEI());
        container.getPEOPLE_INFO().setWS_DEPARTMENT(
                container.getOIVPM04I().getDEPTI());
        container.getPEOPLE_INFO().setWS_PHONE(
                container.getOIVPM04I().getPHONI());
        container.getPEOPLE_INFO().setWS_EMAIL(
                container.getOIVPM04I().getEMALI());
        container.getPEOPLE_INFO().setWS_ADDRESS(
                container.getOIVPM04I().getADDRI());
        if (container.getOIVPM04I().getNAMEL() == 0) {
            container.setOIVPM04I(OIVPINSR_OIVPM04I
                    .createDefaultValueInstance());
            container.setMSGO("NAME ARE NOT FILLED");
            run(_7250_SENDMAP_DATA);
            if (GoTo != null || Return) {
                return;
            }
            run(_5300_RETURN_TRANS_ID);
            if (GoTo != null || Return) {
                return;
            }
        }
        if (container.getOIVPM04I().getDEPTL() == 0) {
            container.setOIVPM04I(OIVPINSR_OIVPM04I
                    .createDefaultValueInstance());
            container.setMSGO("DEPT ARE NOT FILLED");
            run(_7250_SENDMAP_DATA);
            if (GoTo != null || Return) {
                return;
            }
            run(_5300_RETURN_TRANS_ID);
            if (GoTo != null || Return) {
                return;
            }
        }
        // ("EXEC CICS GET COUNTER('OIVPNCS') VALUE(WS-KEY) INCREMENT(1) END-EXEC");
        try {
            GetCounterOption option = GetCounterOption.builder()
                    .counter("OIVPNCS")
                    .value((int) container.getPEOPLE_INFO().getWS_KEY())
                    .increment(1).build();
            Counter.get(option);
            container.getPEOPLE_INFO().setWS_KEY(option.getValue());
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS WRITE FILE(FILE01) RIDFLD(WS-KEY) KEYLENGTH(LEN) FROM(PEOPLE-INFO) LENGTH(DATALEN) END-EXEC");
        try {
            WriteOption option = WriteOption
                    .builder()
                    .file(container.getFILE01())
                    .ridfld(String.valueOf(container.getPEOPLE_INFO()
                            .getWS_KEY()))
                    .keylength((int) container.getLEN())
                    .from(OIVPINSR_PEOPLE_INFO_To_OIVPDS_DOMapper.INSTANCE
                            .toTarget(container.getPEOPLE_INFO()))
                    .length((int) container.getDATALEN()).build();
            File.write(option, OIVPDS_DOF.class);
            container.getPEOPLE_INFO().setWS_KEY(
                    Integer.parseInt(option.getRidfld()));
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        container.setOIVPM04I(OIVPINSR_OIVPM04I.createDefaultValueInstance());
        container.setMSGO("DATA INSERTED, ENTER APPROPRIATE VALUES");
        // ("EXEC CICS QUERY COUNTER('OIVPNCS') VALUE(WS-KEY) END-EXEC");
        try {
            QueryCounterOption option = QueryCounterOption.builder()
                    .counter("OIVPNCS")
                    .value((int) container.getPEOPLE_INFO().getWS_KEY())
                    .build();
            Counter.query(option);
            container.getPEOPLE_INFO().setWS_KEY(option.getValue());
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        container.setIDENO(String.valueOf(container.getPEOPLE_INFO()
                .getWS_KEY()));
        run(_7200_SENDMAP);
        if (GoTo != null || Return) {
            return;
        }
        run(_5300_RETURN_TRANS_ID);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0300_GO_MAIN() throws CicsException {
        // ("EXEC CICS START TRANSID('OIVP') TERMID(EIBTRMID) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            StartOption option = StartOption.builder().transid("OIVP")
                    .termid(eib.getEibTrmid())
                    .inputDto(new OIVPMAIN_InputDto()).build();
            IntervalControlService.start(option);
            WaitObject object = option.getWaitObject();
            setWaitObject(object);
            Start = true;
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        run(_5300_RETURN_TRANS_ID);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _5100_ALWAYS_TEST() throws CicsException {
        container.setDEFINITIONS_OF_EIBAID_FIELD(eib.getEibAid());
        if (OIVPINSR_DEFINITIONS_OF_EIBAID_FIELD_CONDITION.CLEAR_KEY
                .test(container.getDEFINITIONS_OF_EIBAID_FIELD())) {
            run(_5400_QUIT);
            if (GoTo != null || Return) {
                return;
            }
        }
        // ("EXEC CICS ASSIGN STARTCODE(START-CODE) END-EXEC");
        try {
            AssignOption option = AssignOption.builder()
                    .startcode(container.getSTART_CODE()).inputDto(inputDto)
                    .build();
            SystemEnv.assign(option);
            container.setSTART_CODE(option.getStartcode());
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        if (StringUtils.stripEnd(container.getSTART_CODE(), " ")
                .compareTo("TD") == 0 && eib.getEibCalen() != 0) {
            container.setWS_FIRST_TIME_FLAG(1);
        } else {
            container.setWS_FIRST_TIME_FLAG(0);
        }
    }

    void _5200_DATE() throws CicsException {
        // ("EXEC CICS LINK PROGRAM ('OIVPINFO') COMMAREA (WS-DATE-TIME-AREA) END-EXEC");
        try {
            LinkOption option = LinkOption
                    .builder()
                    .program("OIVPINFO")
                    .commarea(
                            OIVPINSR_WS_DATE_TIME_AREA_To_OIVPINFO_DFHCOMMAREADtoMapper.INSTANCE
                                    .toOIVPINFO_DFHCOMMAREADto(container
                                            .getWS_DATE_TIME_AREA()))
                    .inputDto(new OIVPINFO_InputDto()).build();
            ProgramInvoke.link(option);
            container
                    .setWS_DATE_TIME_AREA(OIVPINSR_WS_DATE_TIME_AREA_To_OIVPINFO_DFHCOMMAREADtoMapper.INSTANCE
                            .toOIVPINSR_WS_DATE_TIME_AREA((OIVPINFO_DFHCOMMAREADto) option
                                    .getCommarea()));
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        container.setDATEO(container.getWS_DATE_TIME_AREA().getDCA_DATE());
        container.setTERMO(container.getWS_DATE_TIME_AREA().getDCA_TERM());
        container.setTIMEO(container.getWS_DATE_TIME_AREA().getDCA_TIME()
                .toString());
    }

    void _5300_RETURN_TRANS_ID() throws CicsException {
        // ("EXEC CICS RETURN TRANSID('OIIS') COMMAREA(WS-COMMUNICATION-AREA) END-EXEC");
        try {
            OIVPINSR_DFHCOMMAREADto dfhcommareaDto = new OIVPINSR_DFHCOMMAREADto();
            dfhcommareaDto.setDFHCOMMAREA(container.getWS_COMMUNICATION_AREA());
            ReturnOption option = ReturnOption.builder().transid("OIIS")
                    .commarea(dfhcommareaDto).outputDto(outputDto).build();
            ProgramInvoke.returnProgram(option);
            Return = true;
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _5400_QUIT() throws CicsException {
        // ("EXEC CICS START TRANSID('OIQU') TERMID(EIBTRMID) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            StartOption option = StartOption.builder().transid("OIQU")
                    .termid(eib.getEibTrmid())
                    .inputDto(new OIVPQUIT_InputDto()).build();
            IntervalControlService.start(option);
            WaitObject object = option.getWaitObject();
            setWaitObject(object);
            Start = true;
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS RETURN END-EXEC");
        try {
            if (Objects.equals("DS", inputDto.getSystemDto().getStartCode())
                    || Objects.equals("D", inputDto.getSystemDto()
                            .getStartCode())) {
                OIVPINSR_DFHCOMMAREADto dfhcommareaDto = new OIVPINSR_DFHCOMMAREADto();
                dfhcommareaDto.setDFHCOMMAREA(container.getDFHCOMMAREA());
                outputDto.getSystemDto().setCommarea("DFHCOMMAREA",
                        dfhcommareaDto);
            }
            ReturnOption option = ReturnOption.builder().outputDto(outputDto)
                    .build();
            ProgramInvoke.returnProgram(option);
            Return = true;
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _7100_RECEIVEMAP() throws CicsException {
        // ("EXEC CICS RECEIVE MAP ('OIVPM04') MAPSET ('OIVPM04') INTO (OIVPM04I) RESP (WS-RESPONSE-CODE) END-EXEC");
        try {
            ReceiveMapOption option = ReceiveMapOption.builder().build();
            OIVPM04_OIVPM04_dataToOIVPINSR_OIVPM04IMapperInterface.INSTANCE
                    .toTarget(
                            inputDto.getScreenDto().getOIVPM04_OIVPM04_data(),
                            container.getOIVPM04I());
            OIVPM04_OIVPM04_metaToOIVPINSR_OIVPM04IMapperInterface.INSTANCE
                    .toTarget(
                            inputDto.getScreenDto().getOIVPM04_OIVPM04_meta(),
                            container.getOIVPM04I());
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        if (container.getWS_RESPONSE_CODE() == ResponseCode.NORMAL
                .getResponseCode()) {
        } else if (container.getWS_RESPONSE_CODE() == ResponseCode.MAPFAIL
                .getResponseCode()) {
            container.setMSGO("ENTER APPROPRIATE VALUES");
            run(_7250_SENDMAP_DATA);
            if (GoTo != null || Return) {
                return;
            }
            run(_5300_RETURN_TRANS_ID);
            if (GoTo != null || Return) {
                return;
            }
        } else {
            run(_9999_ABORT);
            if (GoTo != null || Return) {
                return;
            }
        }
    }

    void _7200_SENDMAP() throws CicsException {
        // ("EXEC CICS SEND MAP('OIVPM04') MAPSET('OIVPM04') FROM(OIVPM04O) ERASE END-EXEC");
        try {
            outputDto.setScreenDto(new OIVPINSR_ScreenDto());
            outputDto.setId("tranExecute");
            outputDto.getScreenDto().setMapName("OIVPM04");
            outputDto.getScreenDto().setMapSetName("OIVPM04");
            try {
                OIVPM04_OIVPM04_data oivpm04_oivpm04_data = new OIVPM04_OIVPM04_data();
                OIVPM04_OIVPM04_meta oivpm04_oivpm04_meta = new OIVPM04_OIVPM04_meta();
                OIVPINSR_OIVPM04OToOIVPM04_OIVPM04_dataMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM04O(), oivpm04_oivpm04_data);
                OIVPINSR_OIVPM04OToOIVPM04_OIVPM04_metaMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM04O(), oivpm04_oivpm04_meta);
                outputDto.getScreenDto().setOIVPM04_OIVPM04_data(
                        oivpm04_oivpm04_data);
                outputDto.getScreenDto().setOIVPM04_OIVPM04_meta(
                        oivpm04_oivpm04_meta);
            } catch (Exception e) {
                throw new CicsConditionException(47);
            }
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _7250_SENDMAP_DATA() throws CicsException {
        // ("EXEC CICS SEND MAP('OIVPM04') MAPSET('OIVPM04') FROM(OIVPM04O) DATAONLY END-EXEC");
        try {
            outputDto.setScreenDto(new OIVPINSR_ScreenDto());
            outputDto.setId("tranExecute");
            outputDto.getScreenDto().setMapName("OIVPM04");
            outputDto.getScreenDto().setMapSetName("OIVPM04");
            try {
                OIVPM04_OIVPM04_data oivpm04_oivpm04_data = new OIVPM04_OIVPM04_data();
                OIVPM04_OIVPM04_meta oivpm04_oivpm04_meta = new OIVPM04_OIVPM04_meta();
                OIVPINSR_OIVPM04OToOIVPM04_OIVPM04_dataMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM04O(), oivpm04_oivpm04_data);
                OIVPINSR_OIVPM04OToOIVPM04_OIVPM04_metaMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM04O(), oivpm04_oivpm04_meta);
                outputDto.getScreenDto().setOIVPM04_OIVPM04_data(
                        oivpm04_oivpm04_data);
                outputDto.getScreenDto().setOIVPM04_OIVPM04_meta(
                        oivpm04_oivpm04_meta);
            } catch (Exception e) {
                throw new CicsConditionException(47);
            }
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _9100_INVALID_KEY() throws CicsException {
        container.setOIVPM04I(OIVPINSR_OIVPM04I.createDefaultValueInstance());
        container.setMSGO("INVALID KEY ENTERED");
        run(_7250_SENDMAP_DATA);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _9999_ABORT() throws CicsException {
        container.getWS_ERROR_MESSAGE().setWS_EIBTRNID(eib.getEibTranid());
        container.getWS_ERROR_MESSAGE().setWS_EIBRSRCE(eib.getEibRsrce());
        container.getWS_ERROR_MESSAGE().setWS_EIBRESP(eib.getEibResp());
        container.getWS_ERROR_MESSAGE().setWS_EIBRESP2(eib.getEibResp2());
        // ("EXEC CICS SEND TEXT FROM (\"ERROR\") ERASE ALARM FREEKB END-EXEC");
        try {
            outputDto.getScreenDto().setText("ERROR");
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS RETURN END-EXEC");
        try {
            if (Objects.equals("DS", inputDto.getSystemDto().getStartCode())
                    || Objects.equals("D", inputDto.getSystemDto()
                            .getStartCode())) {
                OIVPINSR_DFHCOMMAREADto dfhcommareaDto = new OIVPINSR_DFHCOMMAREADto();
                dfhcommareaDto.setDFHCOMMAREA(container.getDFHCOMMAREA());
                outputDto.getSystemDto().setCommarea("DFHCOMMAREA",
                        dfhcommareaDto);
            }
            ReturnOption option = ReturnOption.builder().outputDto(outputDto)
                    .build();
            ProgramInvoke.returnProgram(option);
            Return = true;
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }
}
